## deepin-log-viewer 6.1.18

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()
#这里项目名称绝对不能和编译出的target名称一样
project(deepin_log_viewer)
option(DMAN_RELEAE OFF "Install dman resources to system or not")
add_subdirectory(application)
add_subdirectory(logViewerAuth)
add_subdirectory(logViewerTruncate)

add_subdirectory(logViewerService)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    add_subdirectory(tests)
endif()

add_subdirectory(liblogviewerplugin)
option(PERF_ON "open the info of benchmark" ON)

=== application/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()
#set(CMAKE_BUILD_TYPE "Debug")
#project(application)
#add_subdirectory(../3rdparty/docx docx_binary_dir)
#add_subdirectory(../3rdparty/QtXlsxWriter)
configure_file(environments.h.in environments.h @ONLY)
set (EXE_NAME deepin-log-viewer)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::Xml
    Qt5::DBus
    Qt5::Concurrent
    Qt5::Network
#${DtkWidget_LDFLAGS}
#${DtkGui_LDFLAGS}
#${DtkCore_LDFLAGS}
#    ${ICUIL18N_LIBRARIES}
#    ${ICUUC_LIBRARIES}
#     ${SYSTEMD_LIBRARIES}
)

configure_file(config.h.in config.h @ONLY)




set(CMAKE_CXX_STANDARD 17)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
#set(CMAKE_CXX_FLAGS "-g -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ldtkwidget -ldtkgui -ldtkcore")#${EXE_NAME}
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed -fPIE")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -std=c++11")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

set(APP_RES_DIR "assets")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
#-ldtkwidget -ldtkgui -ldtkcore
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
    add_definitions(-DQT_NO_DEBUG_OUTPUT)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -O3")



     execute_process(COMMAND deepin-desktop-ts-convert "init" "assets/deepin-log-viewer.desktop.tmp" "../translations/desktop"
                                        WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE desktop_transinit_var OUTPUT_VARIABLE desktop_transinit_out ERROR_VARIABLE desktop_transinit_error)
     execute_process(COMMAND deepin-desktop-ts-convert "desktop2ts" "assets/deepin-log-viewer.desktop.tmp" "../translations/desktop"
                                                                       WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE desktop_trans_desktop2ts_var OUTPUT_VARIABLE desktop_trans_desktop2ts_out ERROR_VARIABLE desktop_trans_desktop2ts_error)
     execute_process(COMMAND deepin-desktop-ts-convert "ts2desktop" "assets/deepin-log-viewer.desktop.tmp" "../translations/desktop" "assets/deepin-log-viewer.desktop"
           WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE desktop_trans_desktop2ts_var OUTPUT_VARIABLE desktop_trans_desktop2ts_out ERROR_VARIABLE desktop_trans_desktop2ts_error)

    # generate qm files
    execute_process(COMMAND bash "assets/translate_generation.sh"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE trans_var OUTPUT_VARIABLE trans_out ERROR_VARIABLE trans_error)
                message("trans_var ${trans_var} ")#trans_out ${trans_out} trans_error ${trans_error}
 execute_process(COMMAND deepin-policy-ts-convert "init" "assets/com.deepin.pkexec.logViewerAuth.policy.tmp" "../translations/policy/auth"
                                WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE policy2ts_init_var OUTPUT_VARIABLE policy2ts_init_out ERROR_VARIABLE policy2ts_init_error)

    execute_process(COMMAND deepin-policy-ts-convert "policy2ts" "assets/com.deepin.pkexec.logViewerAuth.policy.tmp" "../translations/policy/auth"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE policy2ts_var OUTPUT_VARIABLE policy2ts_out ERROR_VARIABLE policy2ts_error)
                 message("policy2ts_var ${policy2ts_var} policy2ts_out ${policy2ts_out} policy2ts_error ${policy2ts_error}")
    execute_process(COMMAND deepin-policy-ts-convert "ts2policy" "assets/com.deepin.pkexec.logViewerAuth.policy.tmp" "../translations/policy/auth" "assets/com.deepin.pkexec.logViewerAuth.policy"
                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE ts2policy_var OUTPUT_VARIABLE ts2policy_out ERROR_VARIABLE ts2policy_error)
                 message("ts2policy_var ${ts2policy_var} ts2policy_out ${ts2policy_out} ts2policy_error ${ts2policy_error}")
#    execute_process(COMMAND cp "assets/com.deepin.pkexec.logViewerAuth.policy.tmp" "assets/com.deepin.pkexec.logViewerAuth.policy"
#                    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE cp_var OUTPUT_VARIABLE cp_out ERROR_VARIABLE cp_error)
#                   message("cp_var ${cp_var} cp_out ${cp_out} cp_error ${cp_error}")

 execute_process(COMMAND deepin-policy-ts-convert "init" "assets/com.deepin.pkexec.logViewerTruncate.policy.tmp" "../translations/policy/truncate"
                                                      WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE policy2ts_var OUTPUT_VARIABLE policy2ts_out ERROR_VARIABLE policy2ts_error)
execute_process(COMMAND deepin-policy-ts-convert "policy2ts" "assets/com.deepin.pkexec.logViewerTruncate.policy.tmp" "../translations/policy/truncate"
                                   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE policy2ts_var OUTPUT_VARIABLE policy2ts_out ERROR_VARIABLE policy2ts_error)
                                message("policy2ts_var ${policy2ts_var} policy2ts_out ${policy2ts_out} policy2ts_error ${policy2ts_error}")
 execute_process(COMMAND deepin-policy-ts-convert "ts2policy" "assets/com.deepin.pkexec.logViewerTruncate.policy.tmp" "../translations/policy/truncate" "assets/com.deepin.pkexec.logViewerTruncate.policy"
                                   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE ts2policy_var OUTPUT_VARIABLE ts2policy_out ERROR_VARIABLE ts2policy_error)
                                message("ts2policy_var ${ts2policy_var} ts2policy_out ${ts2policy_out} ts2policy_error ${ts2policy_error}")
#execute_process(COMMAND cp "assets/com.deepin.pkexec.logViewerTruncate.policy.tmp" "assets/com.deepin.pkexec.logViewerTruncate.policy"
#                                   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR} RESULT_VARIABLE cp_var OUTPUT_VARIABLE cp_out ERROR_VARIABLE cp_error)
#  message("cp_var ${cp_var} cp_out ${cp_out} cp_error ${cp_error}")
endif ()

add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(RapidJSON)
find_package(Boost)
find_package(XercesC)
find_package(ZLIB)
find_package(PolkitQt5-1)
#pkg_check_modules(qgsettings REQUIRED IMPORTED_TARGET gsettings-qt)
# IMPORTED_TARGET failed to work for some of libs under flatpak env
pkg_check_modules(Other REQUIRED  gsettings-qt)

message("XercesC_FOUND ${XercesC_FOUND}")
message("zlib version: " ${ZLIB_LIBRARIES})

list(APPEND LXW_PRIVATE_INCLUDE_DIRS ${ZLIB_INCLUDE_DIRS})

#pkg_search_module(DtkWidget REQUIRED dtkwidget)
#pkg_search_module(DtkGui REQUIRED dtkgui)
#pkg_search_module(DtkCore REQUIRED dtkcore)
#message(  "dtklib ${DtkWidget_LIBRARIES}
#    ${DtkCore_LIBRARIES}
#    ${DtkGUI_LIBRARIES}")


#message(  "dtkLDFLAGS ${DtkWidget_LDFLAGS}
#    ${DtkGui_LDFLAGS}
#    ${DtkCore_LDFLAGS} ")
#message(  "dtkinclude ${DtkWidget_INCLUDE_DIRS}
#    ${DtkGui_INCLUDE_DIRS}
#    ${DtkCore_INCLUDE_DIRS} ")
#find_package(Icuil18n)
#find_package(Icuuc)
#find_package(Systemd)
#if(ICUIL18N_FOUND)
#    set(CMAKE_AUTORCC ON)
#else(ICUIL18N_FOUND)
#message(ICUIL18N_FOUND "ICUIL18N not found!")
#endif(ICUIL18N_FOUND)


set (APP_CPP_FILES
     main.cpp
     cliapplicationhelper.cpp
     filtercontent.cpp
     displaycontent.cpp
     logcollectormain.cpp
     logfileparser.cpp
     logtreeview.cpp
     journalwork.cpp
     logexportthread.cpp
     utils.cpp
     loglistview.cpp
     logperiodbutton.cpp
     logviewheaderview.cpp
     logviewitemdelegate.cpp
     logiconbutton.cpp
     logspinnerwidget.cpp
     logdetailinfowidget.cpp
     logauththread.cpp
     logapplicationhelper.cpp
     logapplicationparsethread.cpp
     logoocfileparsethread.cpp
     journalbootwork.cpp
     exportprogressdlg.cpp
     logscrollbar.cpp
     logcombox.cpp
     dbusmanager.cpp
     lognormalbutton.cpp
     logapplication.cpp
     sharedmemorymanager.cpp
     dbusproxy/dldbusinterface.cpp
     dbusproxy/dldbushandler.cpp
     logsettings.cpp
     DebugTimeManager.cpp
     wtmpparse.cpp
     logdetailedit.cpp
#     viewsortfilter.cpp
     logallexportthread.cpp
     eventlogutils.cpp
     logbackend.cpp
     logsegementexportthread.cpp
     parsethread/parsethreadbase.cpp
     parsethread/parsethreadkern.cpp
     parsethread/parsethreadkwin.cpp
    )
set (APP_QRC_FILES
assets/resources.qrc
)


set (APP_HEADERS_FILES
    cliapplicationhelper.h
    logcollectormain.h
    displaycontent.h
    logfileparser.h
    filtercontent.h
    structdef.h
    logtreeview.h
    journalwork.h
    logexportwidget.h
    utils.h
    loglistview.h
    logperiodbutton.h
    logviewheaderview.h
    logviewitemdelegate.h
    logiconbutton.h
    logspinnerwidget.h
    logdetailinfowidget.h
    logauththread.h
    logapplicationhelper.h
    logapplicationparsethread.h
    logoocfileparsethread.h
    logdetailedit.h
    wtmpparse.h
    model/log_sort_filter_proxy_model.h
    dbusproxy/dldbusinterface.h
    dbusproxy/dldbushandler.h
#    viewsortfilter.h
    logallexportthread.h
    eventlogutils.h
    logbackend.h
    accessible.h
    logsegementexportthread.h
    parsethread/parsethreadbase.h
    parsethread/parsethreadkern.h
    parsethread/parsethreadkwin.h
    )

# 5. 头文件
# 5.1. 定义函数，用于递归添加头文件
function(include_sub_directories_recursively root_dir)
    if (IS_DIRECTORY ${root_dir})               # 当前路径是一个目录吗，是的话就加入到包含目录
        #message("include dir: " ${root_dir})
        include_directories(${root_dir})
    endif()

    file(GLOB ALL_SUB RELATIVE ${root_dir} ${root_dir}/*) # 获得当前目录下的所有文件，让如ALL_SUB列表中
    foreach(sub ${ALL_SUB})
        if (IS_DIRECTORY ${root_dir}/${sub})
            include_sub_directories_recursively(${root_dir}/${sub}) # 对子目录递归调用，包含
        endif()
    endforeach()
endfunction()

#--------------------libxlsx源码引入---------------------------------
file(GLOB LXW_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/src/*.c)
file(GLOB_RECURSE LXW_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/include *.h)

set (MINIZIP_SOURCES
    ../3rdparty/minizip/ioapi.c
#../3rdparty/minizip/miniunz.c
 ../3rdparty/minizip/minizip.c
../3rdparty/minizip/mztools.c
../3rdparty/minizip/unzip.c
../3rdparty/minizip/zip.c
    )

file(GLOB TMPFILE_SOURCES  ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tmpfileplus/*.c)
 file(GLOB MD5SOURCES   ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/md5/*.c)
#---------------------------------------------
#---------------DOCXFACTORY源码引入----------------------
file(GLOB_RECURSE DOCXFAC_SOURCES  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.cpp" )
file(GLOB_RECURSE DOCXFAC_SOURCES_C  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.c" )

=== liblogviewerplugin/CMakeLists.txt ===
#定义需要的cmake版本
cmake_minimum_required(VERSION 3.13)

#设置工程名字
project(log-viewer-Plugin VERSION 0.1.0)
set(TARGET_NAME logviewerplugin)
set(CMD_NAME logviewerplugin)

#设置编译参数
set(CMAKE_AUTOUIC ON)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ldtkwidget -ldtkgui -ldtkcore")#${EXE_NAME}
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed -fPIE")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -std=c++11")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
#-ldtkwidget -ldtkgui -ldtkcore
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#预定义宏
add_compile_definitions (LOGVIEWERPLUGIN_LIBRARY)
add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
add_definitions( -DLITE_DIV )
add_definitions( -DUSE_UNIONIMAGE )
add_definitions( -DCMAKE_BUILD )

#Qt需要的包
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::Xml
    Qt5::DBus
    Qt5::Concurrent
)

#查找依赖的库
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(RapidJSON)
find_package(Boost)
find_package(XercesC)
find_package(ZLIB)
find_package(PolkitQt5-1)

#设置输出目录
#set(LIBRARY_OUTPUT_PATH ${PROJECT_SOURCE_DIR}/../deepin-album/lib)

#库目录
aux_source_directory(logviewerplugin allSources)

#需要打开的头文件
FILE (GLOB allHeaders
    "*.h"
    "*/*.h"
    "*/*/*.h"
    "*/*/*/*.h"
    "../application/dbusproxy/dldbusinterface.h"
    "../application/dbusproxy/dldbushandler.h"
    "../application/exportprogressdlg.h"
    "../application/journalbootwork.h"
    "../application/journalwork.h"
    "../application/logapplicationparsethread.h"
    "../application/logoocfileparsethread.h"
    "../application/logexportthread.h"
    "../application/logauththread.h"
    "../application/logfileparser.h"
    "../application/sharedmemorymanager.h"
    "../application/utils.h"
    "../application/wtmpparse.h"
    "../application/structdef.h"
    )
#需要打开的代码文件
FILE (GLOB allSources
    "*.cpp"                                   "*.c"
    "*/*.cpp"                                 "*/*.c"
    "*/*/*.cpp"                              "*/*/*.c"
    "*/*/*/*.cpp"                           "*/*/*/*.c"
    "../application/dbusproxy/dldbusinterface.cpp"
    "../application/dbusproxy/dldbushandler.cpp"
    "../application/exportprogressdlg.cpp"
    "../application/journalbootwork.cpp"
    "../application/journalwork.cpp"
    "../application/logapplicationparsethread.cpp"
    "../application/logoocfileparsethread.cpp"
    "../application/logexportthread.cpp"
    "../application/logauththread.cpp"
    "../application/logfileparser.cpp"
    "../application/sharedmemorymanager.cpp"
    "../application/utils.cpp"
    "../application/wtmpparse.cpp"
    "../application/wtmpparse.cpp"
    )
file(GLOB_RECURSE RESOURCES "*.qrc")

#第三方库目录
set(INC_DIR /usr/include/)
set(LINK_DIR /usr/lib/)
include_directories(${INC_DIR})
link_directories(${LINK_DIR})

#--------------------libxlsx源码引入---------------------------------
file(GLOB LXW_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/src/*.c)
file(GLOB_RECURSE LXW_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/include *.h)

#set (MINIZIP_SOURCES
#    ../3rdparty/minizip/ioapi.c
##../3rdparty/minizip/miniunz.c
#    ../3rdparty/minizip/minizip.c
#    ../3rdparty/minizip/mztools.c
#    ../3rdparty/minizip/unzip.c
#    ../3rdparty/minizip/zip.c
#    )

#file(GLOB TMPFILE_SOURCES  ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tmpfileplus/*.c)
#file(GLOB MD5SOURCES   ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/md5/*.c)

#---------------DOCXFACTORY源码引入----------------------
file(GLOB_RECURSE DOCXFAC_SOURCES  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.cpp" )
file(GLOB_RECURSE DOCXFAC_SOURCES_C  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.c" )

#设置不删除生成的文件夹内容文件
set_directory_properties(PROPERTIES CLEAN_NO_CUSTOM 1)

#编译为库
add_library(logviewerplugin SHARED ${allHeaders} ${allSources} ${RESOURCES} ${LXW_SOURCES} ${DOCXFAC_SOURCES} ${DOCXFAC_SOURCES_C} ${QM})
target_compile_options(logviewerplugin PRIVATE ${COMPILE_OPTIONS})
set_target_properties(${TARGET_NAME} PROPERTIES VERSION 0.1.0 SOVERSION 0.1)

#将库安装到指定位置
set(PREFIX /usr)
set(${TARGET_NAME} ${CMAKE_INSTALL_LIBDIR})

#包含目录
include_directories(${CMAKE_INCLUDE_CURRENT_DIR})
include_directories(${CMAKE_CURRENT_BINARY_DIR})
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories( ${Qt5Gui_PRIVATE_INCLUDE_DIRS})
include_directories( ${Qt5Widgets_PRIVATE_INCLUDE_DIRS})
include_directories( ${Boost_INCLUDE_DIRS})
include_directories( ${ZLIB_INCLUDE_DIRS})
message("ZLIB_INCLUDE_DIRS ${ZLIB_INCLUDE_DIRS}")
include_directories( ${RapidJSON_INCLUDE_DIRS})
include_directories(${XercesC_INCLUDE_DIRS})
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/DocxFactory/include")

#引用库
target_link_libraries(${TARGET_NAME}  ${LINK_LIBS} -lsystemd -licui18n -licuuc  -ldl -fPIC)
target_link_libraries(${TARGET_NAME} ${DtkWidget_LIBRARIES})
target_link_libraries(${TARGET_NAME} ${DtkCore_LIBRARIES})
target_link_libraries(${TARGET_NAME} ${DtkGUI_LIBRARIES})
#当binutils>=2.22时，对于链接的静态库链接的静态库，cmake并不会递归链接，所以需要手动链接libxlsxwriter需要的lzlib
target_link_libraries(${TARGET_NAME} ${ZLIB_LIBRARIES})
target_link_libraries(${TARGET_NAME} ${Boost_LIBRARIES})
target_link_libraries(${TARGET_NAME} ${RapidJSON_LIBRARIES})
target_link_libraries(${TARGET_NAME} ${XercesC_LIBRARIES})
target_link_libraries(${TARGET_NAME} PolkitQt5-1::Agent)

include(GNUInstallDirs)
configure_file(liblogviewerplugin.pc.in ${PROJECT_BINARY_DIR}/liblogviewerplugin.pc @ONLY)

#安装位置
install(TARGETS ${CMD_NAME} DESTINATION ${CMAKE_INSTALL_LIBDIR})

install(FILES
    ../application/structdef.h
    DESTINATION include/liblogviewerplugin)
install(FILES
    src/plugininterfaces/logviewerplugininterface.h
    DESTINATION include/liblogviewerplugin/plugininterfaces)
install(FILES
    src/plugins/logviewerplugin.h
    DESTINATION include/liblogviewerplugin/plugins)

install(FILES ${PROJECT_BINARY_DIR}/liblogviewerplugin.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

#translations翻译
#file(GLOB TS LIST_DIRECTORIES false translations/liblogviewerplugin*.ts)
#set_source_files_properties(${TS} PROPERTIES OUTPUT_LOCATION ${PROJECT_SOURCE_DIR}/translations)

#qt5_create_translation(QM ${allSources}  ${GLOB})

#if (NOT (${CMAKE_BUILD_TYPE} MATCHES "Debug"))
#    qt5_create_translation(QM ${allSources} ${TS})
#endif ()

#install(DIRECTORY ${PROJECT_SOURCE_DIR}/translations
#    DESTINATION ${PREFIX}/share/liblogviewerplugin
#    FILES_MATCHING PATTERN "*.qm")

=== debian/changelog ===
deepin-log-viewer (6.1.18) unstable; urgency=medium

  * feat: Segmented export supports doc and xls formats for export
  * fix: Fix the issue of progress bar not displaying progress(Bug: 251937)
  * feat: Crash report content optimization(Task: 10320240422)
  * fix: Fix two security vulnerabilities(Bug: 253967)
  * fix: Optimized file reading speed
  * fix: Fix issues with abnormal search functionality
  * fix: fix compile problem on longarrch
  * fix: Security vulnerability reinforcement
  * fix: remove /bin/bash in service if necessary
  * fix: UI interface in English(Bug: 256789)
  * fix: The "level" on the page is displayed as "level"(Bug: 260291)

 -- houchengqiu <houchengqiu@uniontech.com>  Tue, 18 Jun 2024 16:00:41 +0800

deepin-log-viewer (6.1.17) unstable; urgency=medium

  * perf: Optimization of kernel/window management log memory usage
  * fix: Optimize search functionality
  * fix: Fix the issue of repeatedly popping up authentication windows(Bug: 251521)
  * fix: Fix the issue of segment export not being able to be cancelled(Bug: 251515)
  * fix: Refinement of kernel log segmentation export and cancellation of authentication logic(Bug: )
  * fix: Search function optimization 2nd && add logs

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 19 Apr 2024 13:22:11 +0800

deepin-log-viewer (6.1.16) unstable; urgency=medium

  * fix: The coredump reporter service switches from system mode to user mode
  * fix: Repair failed in building with a 64-bit time_t on a 32-bit(Bug: 250313)

 -- lijiaxuan <lijiaxuan@uniontech.com>  Fri, 12 Apr 2024 17:19:11 +0800

deepin-log-viewer (6.1.15) unstable; urgency=medium

  * feat: kwin crash log buried point report(Task: 330013)
  * chore: adjust coredump report interval
  * fix: Correction of abnormal last reporting time

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 21 Mar 2024 16:21:59 +0800

deepin-log-viewer (6.1.14) unstable; urgency=medium

  * fix: Fix the issue of filter option filtering without content when there is only one submodule(Bug: 244901)
  * fix: Delete dump temporary file from service backend(Bug: 241927)
  * fix: Remove the. config directory from the root directory(Bug: 244995)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 13 Mar 2024 15:00:43 +0800

deepin-log-viewer (6.1.13) unstable; urgency=medium

  * fix: Resolve the issue of adding sudo not being able to export logs(Bug: 238985)
  * chore: [TS] Update international translation files(Bug: 193739)
  * fix: Resolve the issue of Sudo export logs being empty(Bug: 238985)
  * fix: Fix the issue of parent directory permissions being changed during export
  * fix: Unzip may overwrite linked file data(Bug: 243387)
  * fix: fix app name can not show chinese

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 22 Feb 2024 13:44:46 +0800

deepin-log-viewer (6.1.12) unstable; urgency=medium

  * fix: Add -v option version info(Bug: 236241)
  * fix: Adapt to the type of PGX log display(Bug: 240851)

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 01 Feb 2024 14:09:32 +0800

deepin-log-viewer (6.1.11) unstable; urgency=medium

  * fix: modify debug-config json

 -- houchengqiu <houchengqiu@uniontech.com>  Mon, 15 Jan 2024 14:10:59 +0800

deepin-log-viewer (6.1.10) unstable; urgency=medium

  * chore: Update version 6.1.10

 -- houchengqiu <houchengqiu@uniontech.com>  Thu, 11 Jan 2024 10:30:32 +0800

deepin-log-viewer (6.1.9) unstable; urgency=medium

  * feat: Log specification adaptation 2nd
  * feat: Log specification adaptation 2nd- merge export
  * fix: Resolve the issue of JSON configuration not being able to control application visibility(Bug: 237801)
  * feat: Debug mode log adaptation
  * fix: Resolve the issue of blank items in the application list(Bug: 237785)
  * feat: add package version information on crash burial point(Bug: 236991)
  * fix: Change the JSON visible field to 0 in debugging mode configuration(Bug: 238925)
  * fix: Fix the issue where using the - d parameter - m cannot export logs(Bug: 238967)

 -- houchengqiu <houchengqiu@uniontech.com>  Wed, 10 Jan 2024 11:46:04 +0800

deepin-log-viewer (6.1.8) unstable; urgency=medium

  * fix: Fix security vulnerabilities introduced by LD_PRELOAD 2nd(Bug: 234125)
  * chore: Optimization of output path whitelist inspection methods(Bug: 236471)

 -- houchengqiu <houchengqiu@uniontech.com>  Mon, 25 Dec 2023 17:17:00 +0800

deepin-log-viewer (6.1.7) unstable; urgency=medium

  * fix: Fix security vulnerabilities introduced by LD_PRELOAD(Bug: HW23-1232)
  * feat: Rectification of DBus security coding standards
  * fix: systemd service add memory limits 8G
  * fix: coredump map info only parsed in report coredump(Bug: 233653)
  * chore: Code review issue modification
  * fix: Resolve the issue of incomplete display of crash logs(Bug: 234131)

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 22 Dec 2023 13:21:34 +0800

deepin-log-viewer (6.1.6) unstable; urgency=medium

  * fix: clear qt warning logs
  * fix: Fix the issue of incomplete acquisition of file base names(Bug: 228425)
  * feat: report coredump add stackinfo
  * fix: not get core file maps (#237)
    Thanks to groveer
  * fix: Resolve the issue of failure to obtain stack maps address for crash information

 -- Deepin Packages Builder <packages@deepin.org>  Thu, 30 Nov 2023 17:49:19 +0800

deepin-log-viewer (6.1.5) unstable; urgency=medium

  * fix: Adjust the display rules of application names in the application list(Bug: 223969)
  * feat: Rich command line export function
  * feat: Command line export by condition
  * fix: Remove command authentication
  * fix: CLI export type logs to diretory(Bug: 225107)
  * fix: CLI export return correct errcode(Bug: 225365)
  * fix: fix export specify app log failed problem(Bug: 225077)
  * fix: fix cli export kwin log failed problem(Bug: 225427)
  * fix: ix cli export to no-write dir can not quit(Bug: 225553)
  * fix: Add validity verification of cli export level parameters(Bug: 225567)


=== debian/control ===
Source: deepin-log-viewer
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends: debhelper (>= 11),cmake, pkg-config, qtbase5-dev, qtchooser (>= 55-gc9562a1-1~),qt5-qmake, libdtkwidget-dev, libdtkgui-dev, qttools5-dev-tools, libqt5svg5-dev, libsystemd-dev, libicu-dev, qttools5-dev, libdframeworkdbus-dev, libgtest-dev, libgmock-dev, libkf5codecs-dev, libzip-dev, libxerces-c-dev, libboost-dev, libminizip-dev, rapidjson-dev, libltdl-dev, libpolkit-qt5-1-dev, libgsettings-qt-dev, libgio-qt-dev
Standards-Version: 4.1.3

Package: deepin-log-viewer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description:Log Viewer is a useful tool for viewing system logs.
 Log viewer is a tool that collects logs generated when an application
 is running, for example, logs generated when operating system and
 applications start up and run. You can do trouble-shooting and solve
 problems quickly by analyzing logs.
Recommends: uos-reporter, deepin-event-log    

Package: liblogviewerplugin
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts:
 liblog-viewer-plugin
Replaces:
 liblog-viewer-plugin
Recommends: libqt5libqgtk2
Description: Log Viewer Plugin library.
 Deepin Log Viewer Plugin library.

Package: liblogviewerplugin-dev
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, liblogviewerplugin(=${binary:Version})
Conflicts:
 liblog-viewer-plugin-dev
Replaces:
 liblog-viewer-plugin-dev
Recommends: libqt5libqgtk2
Description: Log Viewer Plugin library development headers.
 Deepin Log Viewer Plugin library development headers.

## deepin-log-viewer 6.5.2

=== logViewerAuth/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()

project(logViewerAuth LANGUAGES CXX)
set (EXE_NAME logViewerAuth)
set(LINK_LIBS
    Qt5::Core
)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -std=c++11")
#set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
#set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")

if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
set (AUTH_CPP_FILES
        main.cpp
       viewapplication.cpp
       viewapplication.h
    )
add_executable (${EXE_NAME}
    ${AUTH_CPP_FILES}
)

# Find the library
find_package(Qt5Core REQUIRED)
set(CMAKE_INSTALL_PREFIX /usr)
# Install files
install(TARGETS ${EXE_NAME} DESTINATION bin)
target_link_libraries(${EXE_NAME} ${LINK_LIBS} )

=== logViewerService/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.7)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()
#这里项目名称绝对不能和编译出的target名称一样
project(log-view-service)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
endif()

#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")

set(APP_RES_DIR "assets")
set(APP_SERVICE "${APP_RES_DIR}/data/com.deepin.logviewer.service")
set(APP_SYSTEMD_SERVICE "${APP_RES_DIR}/data/deepin-log-viewer-daemon.service")
set(APP_CONFIG "${APP_RES_DIR}/data/com.deepin.logviewer.conf")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
# Find the library
find_package(PkgConfig REQUIRED)
find_package(DtkGui REQUIRED)
find_package(Qt5 COMPONENTS
    Core
    Widgets
    DBus
REQUIRED)
pkg_check_modules(3rd_lib REQUIRED
         gio-qt
        )

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    ${DtkCore_LIBRARIES}
)

file(GLOB ALL_SOURCES "*.cpp")
file(GLOB ALL_HEADERS "*.h")

include_directories(../application)
add_executable(${PROJECT_NAME} ${ALL_SOURCES} ${ALL_HEADERS})
target_include_directories(${PROJECT_NAME} PUBLIC
    ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
    ${PROJECT_BINARY_DIR}
    ${3rd_lib_INCLUDE_DIRS}
)

target_include_directories(${PROJECT_NAME} PUBLIC ${DtkWidget_INCLUDE_DIRS} ${OBJECT_BINARY_DIR})
target_link_libraries(${PROJECT_NAME}
    ${LINK_LIBS}
    ${DtkWidget_LIBRARIES}
    ${Qt5Widgets_LIBRARIES}
    ${3rd_lib_LIBRARIES}
)
set(CMAKE_INSTALL_PREFIX /usr)

# Install files
install(TARGETS ${PROJECT_NAME} DESTINATION lib/deepin-daemon/)
install(FILES ${APP_SERVICE} DESTINATION share/dbus-1/system-services/)
install(FILES ${APP_CONFIG} DESTINATION share/dbus-1/system.d/)
# systemd service
install(FILES ${APP_SYSTEMD_SERVICE} DESTINATION lib/systemd/system/)

=== tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13)

if (NOT DEFINED VERSION)
    set(VERSION 1.2.2)
endif ()
configure_file(../application/environments.h.in environments.h @ONLY)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
set(LINK_LIBS
    Qt5::Core
    Qt5::Widgets
    Qt5::Gui
    Qt5::Xml
    Qt5::DBus
    Qt5::Concurrent
    Qt5::Test
    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    PkgConfig::qgsettings
)

#可访问private
ADD_COMPILE_OPTIONS(-fno-inline)
set (PROJECT_NAME_TEST deepin-log-viewer-test)
set (PROJECT_NAME_PLUGIN_TEST deepin-log-viewer-plugin-test)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_VERBOSE_MAKEFILE ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
#set(CMAKE_CXX_FLAGS "-g -Wall")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -ldtkwidget -ldtkgui -ldtkcore")#${PROJECT_NAME_TEST}
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-access-control")
#编译生成覆盖环境
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage")
#添加-fno-inline编译选项，禁止内联，能获取到函数地址，可以对内联函数进行打桩
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-inline")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
#-ldtkwidget -ldtkgui -ldtkcore
if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
#安全测试加固编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -z relro -z now -z noexecstack -pie")
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  -fstack-protector-all")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS}  -fstack-protector-all")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

#不显示未使用的函数告警
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-function")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-function")
#不显示未使用的变量告警
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-variable")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-variable")
#不显示已赋值但未使用的变量告警
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wno-unused-but-set-variable")
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-unused-but-set-variable")

configure_file(../application/config.h.in config.h @ONLY)
add_definitions(-DUSE_POLKIT -DENABLE_INACTIVE_DISPLAY)
# Find the library
find_package(PkgConfig REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5Xml REQUIRED)
find_package(Qt5Concurrent REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(DtkWidget REQUIRED)
find_package(DtkGui REQUIRED)
find_package(DtkCore REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Test REQUIRED)
add_definitions(${Qt5Test_DEFINITIONS})
find_package(RapidJSON)
find_package(Boost)
find_package(XercesC)
find_package(ZLIB)
pkg_check_modules(qgsettings REQUIRED IMPORTED_TARGET gsettings-qt)

FILE(GLOB allSource
     ../application/filtercontent.cpp
     ../application/displaycontent.cpp
     ../application/logcollectormain.cpp
     ../application/logfileparser.cpp
     ../application/logtreeview.cpp
     ../application/journalwork.cpp
     ../application/logexportthread.cpp
     ../application/utils.cpp
     ../application/loglistview.cpp
     ../application/logperiodbutton.cpp
     ../application/logviewheaderview.cpp
     ../application/logviewitemdelegate.cpp
     ../application/logiconbutton.cpp
     ../application/logspinnerwidget.cpp
     ../application/logdetailinfowidget.cpp
     ../application/logauththread.cpp
     ../application/logapplicationhelper.cpp
     ../application/logapplicationparsethread.cpp
     ../application/logoocfileparsethread.cpp
     ../application/journalbootwork.cpp
     ../application/exportprogressdlg.cpp
     ../application/logscrollbar.cpp
     ../application/model/log_sort_filter_proxy_model.cpp
     ../application/logcombox.cpp
     ../application/dbusmanager.cpp
     ../application/lognormalbutton.cpp
     ../application/logsearchedit.cpp
     ../application/logapplication.cpp
     ../application/sharedmemorymanager.cpp
     ../application/logsettings.cpp
     ../application/logbackend.cpp
     ../application/eventlogutils.cpp
     ../application/wtmpparse.cpp
     ../application/DebugTimeManager.cpp
     ../application/logdetailedit.cpp
     ../application/dbusproxy/dldbusinterface.cpp
     ../application/dbusproxy/dldbushandler.cpp
#     ../application/viewsortfilter.cpp
     ../application/logsegementexportthread.cpp
     ../application/logallexportthread.cpp
     ../application/parsethread/parsethreadbase.cpp
     ../application/parsethread/parsethreadkern.cpp
     ../application/parsethread/parsethreadkwin.cpp
)
FILE(GLOB qrcFiles
    ../application/assets/resources.qrc
)
FILE(GLOB allTestSource
    src/*.h
    src/*.cpp
    common/*.cpp
    dbusproxy/*.cpp
)
FILE(GLOB allPluginTestSource
    src/ut_main.cpp
    ut_logviewerplugin/*.cpp
    ut_logviewerplugin/*.h
)

# 5. 头文件
# 5.1. 定义函数，用于递归添加头文件
function(include_sub_directories_recursively root_dir)
    if (IS_DIRECTORY ${root_dir})               # 当前路径是一个目录吗，是的话就加入到包含目录
        #message("include dir: " ${root_dir})
        include_directories(${root_dir})
    endif()

    file(GLOB ALL_SUB RELATIVE ${root_dir} ${root_dir}/*) # 获得当前目录下的所有文件，让如ALL_SUB列表中
    foreach(sub ${ALL_SUB})
        if (IS_DIRECTORY ${root_dir}/${sub})
            include_sub_directories_recursively(${root_dir}/${sub}) # 对子目录递归调用，包含
        endif()
    endforeach()
endfunction()

find_library(ICUIL18N_LIB icui18n)
find_library(ICUUC_LIB icuuc)

#--------------------libxlsx源码引入---------------------------------
file(GLOB LXW_SOURCES ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/src/*.c)
file(GLOB_RECURSE LXW_HEADERS RELATIVE ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter/include *.h)

set (MINIZIP_SOURCES
    ../3rdparty/minizip/ioapi.c
 ../3rdparty/minizip/minizip.c
../3rdparty/minizip/mztools.c
../3rdparty/minizip/unzip.c
../3rdparty/minizip/zip.c
    )

file(GLOB TMPFILE_SOURCES  ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tmpfileplus/*.c)
file(GLOB MD5SOURCES   ${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/md5/*.c)
#---------------DOCXFACTORY源码引入----------------------
file(GLOB_RECURSE DOCXFAC_SOURCES  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.cpp" )
file(GLOB_RECURSE DOCXFAC_SOURCES_C  "${PROJECT_SOURCE_DIR}/3rdparty/DocxFactory/src/*.c" )
#-----------------------------------------------------
#--------------------liblogviewerplugin源码引入---------------------------------
#GLOB_RECURSE递归搜索
file(GLOB_RECURSE LVP_SOURCES
    "../liblogviewerplugin/src/*.cpp"
    "../application/dbusproxy/dldbusinterface.cpp"
    "../application/dbusproxy/dldbushandler.cpp"
    "../application/dbusmanager.cpp"
    "../application/exportprogressdlg.cpp"
    "../application/journalbootwork.cpp"
    "../application/journalwork.cpp"
    "../application/logapplicationparsethread.cpp"
    "../application/logoocfileparsethread.cpp"
    "../application/logauththread.cpp"
    "../application/logfileparser.cpp"
    "../application/sharedmemorymanager.cpp"
    "../application/logsettings.cpp"
    "../application/utils.cpp"
    "../application/wtmpparse.cpp"
    "../application/logapplicationhelper.cpp"
    "../application/logexportthread.cpp"
    "../application/logsegementexportthread.cpp"
    "../application/parsethread/parsethreadbase.cpp"
    "../application/parsethread/parsethreadkern.cpp"
    "../application/parsethread/parsethreadkwin.cpp"
    )
file(GLOB_RECURSE LVP_HEADERS
    "../liblogviewerplugin/src/*.h"
    "../application/dbusproxy/dldbusinterface.h"
    "../application/dbusproxy/dldbushandler.h"
    "../application/dbusmanager.h"
    "../application/exportprogressdlg.h"
    "../application/journalbootwork.h"
    "../application/journalwork.h"
    "../application/logapplicationparsethread.h"
    "../application/logoocfileparsethread.h"
    "../application/logauththread.h"
    "../application/logfileparser.h"
    "../application/sharedmemorymanager.h"
    "../application/logsettings.h"
    "../application/utils.h"
    "../application/wtmpparse.h"
    "../application/structdef.h"
    "../application/logapplicationhelper.h"
    "../application/logexportthread.h"
    "../application/logsegementexportthread.h"
    "../application/parsethread/parsethreadbase.h"
    "../application/parsethread/parsethreadkern.h"
    "../application/parsethread/parsethreadkwin.h"
    )
#---------------------------------------------

include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/libxlsxwriter")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/DocxFactory/include")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/md5")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/minizip")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../3rdparty/tmpfileplus")
include_directories(${CMAKE_CURRENT_SOURCE_DIR})
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../application")
include_sub_directories_recursively("${CMAKE_CURRENT_SOURCE_DIR}/../liblogviewerplugin")
include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories( ${Qt5Gui_PRIVATE_INCLUDE_DIRS})
include_directories( ${Qt5Widgets_PRIVATE_INCLUDE_DIRS})
include_directories( ${Qt5TestLib_LIBRARIES})
include_directories( ${Boost_INCLUDE_DIRS})
include_directories( ${ZLIB_INCLUDE_DIRS})
include_directories( ${RapidJSON_INCLUDE_DIRS})
include_directories(${XercesC_INCLUDE_DIRS})
find_package(GTest REQUIRED)
include_directories(${GTEST_INCLUDE_DIRS})
find_package(PolkitQt5-1)
include_directories(src)

add_executable (${PROJECT_NAME_TEST} ${allSource} ${APP_QRC_FILES} ${APP_QM_FILES} ${qrcFiles}   ${allTestSource} ${MINIZIP_SOURCES} ${LXW_SOURCES} ${DOCXFAC_SOURCES} ${DOCXFAC_SOURCES_C} ${TMPFILE_SOURCES} ${MD5SOURCES})
#添加插件单元测试进程
add_executable (${PROJECT_NAME_PLUGIN_TEST} ${allPluginTestSource} ${LVP_HEADERS} ${LVP_SOURCES} ${MINIZIP_SOURCES} ${LXW_SOURCES} ${DOCXFAC_SOURCES} ${DOCXFAC_SOURCES_C} ${TMPFILE_SOURCES} ${MD5SOURCES})

target_link_libraries(${PROJECT_NAME_TEST} ${LINK_LIBS} -lsystemd -licui18n -licuuc ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread -ldl -fPIC)
#当binutils>=2.22时，对于链接的静态库链接的静态库，cmake并不会递归链接，所以需要手动链接libxlsxwriter需要的lzlib
target_link_libraries(${PROJECT_NAME_TEST} ${ZLIB_LIBRARIES})
target_link_libraries(${PROJECT_NAME_TEST} ${Boost_LIBRARIES})
target_link_libraries(${PROJECT_NAME_TEST} ${RapidJSON_LIBRARIES})
#target_link_libraries(${PROJECT_NAME_TEST} ${ImageMagick_LIBRARIES})
target_link_libraries(${PROJECT_NAME_TEST} ${XercesC_LIBRARIES})
target_link_libraries(${PROJECT_NAME_TEST} PolkitQt5-1::Agent)

target_link_libraries(${PROJECT_NAME_PLUGIN_TEST} ${LINK_LIBS} -lsystemd -licui18n -licuuc ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} pthread -ldl -fPIC)
target_link_libraries(${PROJECT_NAME_PLUGIN_TEST} PolkitQt5-1::Agent)
target_link_libraries(${PROJECT_NAME_PLUGIN_TEST} ${ZLIB_LIBRARIES})
target_link_libraries(${PROJECT_NAME_PLUGIN_TEST} ${XercesC_LIBRARIES})

=== debian/changelog ===
deepin-log-viewer (6.5.2) unstable; urgency=medium

  * adapt compact mode 

 -- houchengqiu <houchengqiu@uniontech.com>  Fri, 08 Nov 2024 13:49:23 +0800

deepin-log-viewer (6.5.1) unstable; urgency=medium

  * remove kwayland-shell env 

 -- Liu zheng <liuzheng@uniontech.com>  Wed, 06 Nov 2024 17:17:32 +0800

deepin-log-viewer (6.5.0) unstable; urgency=medium

  * chore: Code format organization
  * fix: Fix the issue of upgrade failure after enabling level protection(Bug: 258569)
  * fix: Fix crashes when there is no permission to view other logs(Bug: 266019)
  * fix: DBus calls authentication adds MNT check
  * feat: adapt treeland(Influence: Treeland)
  * fix: out-of-bounds access error

 -- renbin <renbin@uniontech.com>  Wed, 21 Aug 2024 15:34:48 +0800

## deepin-log-viewer 6.5.4+ds1

=== logViewerService/CMakeLists.txt ===
--- 
+++ 
@@ -34,6 +34,7 @@
 # Find the library
 find_package(PkgConfig REQUIRED)
 find_package(DtkGui REQUIRED)
+find_package(PolkitQt5-1)
 find_package(Qt5 COMPONENTS
     Core
     Widgets
@@ -66,6 +67,7 @@
     ${DtkWidget_LIBRARIES}
     ${Qt5Widgets_LIBRARIES}
     ${3rd_lib_LIBRARIES}
+    PolkitQt5-1::Agent
 )
 set(CMAKE_INSTALL_PREFIX /usr)

=== debian/changelog ===
deepin-log-viewer (6.5.4+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
    + Upgrade to C++17 standard. (Closes: #1092336)
  * debian/control: Add new build-dep libgsettings-qt-dev.
  * debian/control: Add build-dep libgio-qt-dev.
  * debian/patches: Refresh patches.

 -- Boyuan Yang <byang@debian.org>  Tue, 07 Jan 2025 09:54:38 -0500

deepin-log-viewer (5.9.7+ds1-4) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Boyuan Yang <byang@debian.org>  Wed, 30 Oct 2024 15:37:24 -0400

deepin-log-viewer (5.9.7+ds1-4~exp1) experimental; urgency=medium

  * Team upload.
  * Test build with libxlsxwriter (>= 1.1.9).

 -- Boyuan Yang <byang@debian.org>  Tue, 29 Oct 2024 23:03:16 -0400

deepin-log-viewer (5.9.7+ds1-3) unstable; urgency=medium

  * Team upload.
  * debian/patches/0003-fix-32-64-time_t.patch: Cherry-pick upstream
    patch to fix build with 64-bit time_t build. (Closes: #1067560)

 -- Boyuan Yang <byang@debian.org>  Sat, 20 Apr 2024 09:34:08 -0400

=== debian/control ===
Source: deepin-log-viewer
Section: misc
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Ma Aiguo <imaiguo@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libboost-dev,
 libdframeworkdbus-dev,
 libdtkgui-dev,
 libdtkwidget-dev,
 libgio-qt-dev,
 libgmock-dev,
 libgsettings-qt-dev,
 libgtest-dev,
 libicu-dev,
 libkf5codecs-dev,
 libltdl-dev,
 libminizip-dev,
 libpolkit-qt5-1-dev,
 libqt5svg5-dev,
 libsystemd-dev,
 libxerces-c-dev,
 libxlsxwriter-dev (>= 1.1.9),
 libzip-dev,
 pkgconf,
 qt5-qmake,
 qtbase5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 rapidjson-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://github.com/linuxdeepin/deepin-log-viewer
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-log-viewer

Package: deepin-log-viewer
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Log Viewer is a useful tool for viewing system logs
 Log viewer is a tool that collects logs generated when an application
 is running, for example, logs generated when operating system and
 applications start up and run. You can do trouble-shooting and solve
 problems quickly by analyzing logs.
